#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

#include "util.h"
#include "pattern.h"
#include "map.h"
#include "layout.h"
#include "action.h"


static char tr[256];


struct action *new_action(void (*fn)(const struct action *act))
{
    struct action *act;

    act = alloc_type(struct action);
    act->fn = fn;
    act->next = NULL;
    return act;
}


void action_accept(const struct action *act)
{
    gtk_main();
}


void action_exit(const struct action *act)
{
    exit(0);
}


void action_layout(const struct action *act)
{
    layout_display(act->s1);
}


void action_map(const struct action *act)
{
    map_select(act->s1);
}


void action_reset(const struct action *act)
{
    pattern_clear();
}


void action_send(const struct action *act)
{
    if (act->s1[0] && !act->s1[1] && tr[(unsigned char) *act->s1])
	printf("%c", tr[(unsigned char) *act->s1]);
    else
	printf("%s", act->s1);
    fflush(stdout);
}


void action_tr(const struct action *act)
{
    int end = strlen(act->s1);
    int i;

    for (i = 0; i != end; i++)
	tr[(unsigned char) act->s1[i]] = act->s2[i];
}


void do_actions(const struct action *act)
{
    while (act) {
	act->fn(act);
	act = act->next;
    }
}
