#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "util.h"
#include "pattern.h"
#include "map.h"


struct map {
    const char *name;
    const struct pattern *pattern;
    const struct map *next;
} *maps = NULL;


void map_new(const char *name)
{
    struct map *map;

    map = alloc_type(struct map);
    map->name = name;
    map->pattern = pattern_get();
    map->next = maps;
    maps = map;
}


void map_select(const char *name)
{
    const struct map *map;

    for (map = maps; map; map = map->next)
	if (!strcmp(map->name, name)) {
	    pattern_merge(map->pattern);
	    return;
	}
    fprintf(stderr,"map \"%s\" not found\n", name);
    exit(1);
}
